/*******************************************************************************
 * Copyright (c) 2011 Google, Inc.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 *    Google, Inc. - initial API and implementation
 *******************************************************************************/
package com.something.layout;

import org.eclipse.jface.preference.IPreferenceStore;
import org.eclipse.wb.core.branding.BrandingUtils;
import org.eclipse.wb.internal.core.model.description.ToolkitDescription;
import org.eclipse.wb.internal.core.model.generation.GenerationSettings;
import org.osgi.framework.Bundle;

/**
 * {@link ToolkitDescription} for eRCP.
 * 
 * @author scheglov_ke
 * @coverage ercp
 */
public final class SomethingToolkitDescription extends ToolkitDescription {
	public static final ToolkitDescription INSTANCE = new SomethingToolkitDescription();
	// //////////////////////////////////////////////////////////////////////////
	//
	// Instance fields
	//
	// //////////////////////////////////////////////////////////////////////////
	private final IPreferenceStore store = Activator.getDefault().getPreferenceStore();
	// //////////////////////////////////////////////////////////////////////////
	//
	// Initialization
	//
	// //////////////////////////////////////////////////////////////////////////
	private boolean m_initialized;

	void initialize() {
		if (!m_initialized) {
			m_initialized = true;
		}
	}

	// //////////////////////////////////////////////////////////////////////////
	//
	// Access
	//
	// //////////////////////////////////////////////////////////////////////////
	@Override
	public String getId() {
		return "com.something.layout";
	}

	@Override
	public String getName() {
		return "Some toolkit";
	}

	@Override
	public String getProductName() {
		return BrandingUtils.getBranding().getProductName();
	}

	@Override
	public Bundle getBundle() {
		return Activator.getDefault().getBundle();
	}

	@Override
	public IPreferenceStore getPreferences() {
		return store;
	}

	// //////////////////////////////////////////////////////////////////////////
	//
	// Code generation
	//
	// //////////////////////////////////////////////////////////////////////////
	@Override
	public GenerationSettings getGenerationSettings() {
		return null;
	}
}
